"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TBlock = exports.default = void 0;

var _HTMLContentModel = _interopRequireDefault(require("../model/HTMLContentModel"));

var _TNode = _interopRequireDefault(require("./TNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const TBlock = function TBlock(init) {
  this.initialize(init);
}; //@ts-ignore


exports.TBlock = TBlock;
TBlock.prototype = new _TNode.default('block', 'TBlock');

TBlock.prototype.matchContentModel = function matchContentModel(contentModel) {
  return contentModel === _HTMLContentModel.default.block || contentModel === _HTMLContentModel.default.mixed;
};

TBlock.prototype.collapseChildren = function collapseChildren(params) {
  let indexesToSplice = [];
  this.children.forEach((child, i) => {
    child.collapse(params);

    if (child.isEmpty()) {
      indexesToSplice.push(i);
    }
  });
  this.spliceChildren(indexesToSplice);
};

var _default = TBlock;
exports.default = _default;
//# sourceMappingURL=TBlock.js.map