import { TNodeCtor } from './TNode';
import { TNodeInit, TNodeImpl, TNodeShape, DocumentContext } from './tree-types';
export declare type TDocumentInit = Omit<TNodeInit, 'elementModel'>;
export interface TDocumentImpl extends TNodeImpl<TNodeInit> {
    readonly context: Readonly<DocumentContext>;
    /**
     * Iterate over children and extract meta-information into context field.
     * Replace children with a single-element array containing the body.
     */
    parseChildren(): void;
}
interface TDocument extends TNodeShape {
    readonly context: Readonly<DocumentContext>;
}
declare const TDocument: TNodeCtor<TDocumentInit, TDocumentImpl>;
export { TDocument };
export default TDocument;
